import matplotlib.pyplot as plt
import wfdb

#=======================================程序参数设定=======================================
#采样率Hz
ADC_Fs = 250
#除数
ADC_CHU = 4



#=======================================程序运行部分=======================================

record = wfdb.rdrecord('C:/Users/XIA/Desktop/demo/cu01')
print('记录名称：',record.record_name)
print('采样频率：',record.fs, 'Hz')
print(record.adc_gain)
print(type(record.d_signal))
print(type(record.p_signal))


d_signal = record.adc()
record.adc(inplace=True)
record.dac(inplace=True)
#print(d_signal[0:2000])
#plt.plot(d_signal[0: 2000])
#plt.show()


#转化成list格式
ConvertList = d_signal.tolist()
#因为采样率为12bit,所以加上2048作为中点
for i in range(0, len(ConvertList)):
	ConvertList[i][0] = ConvertList[i][0] + 2048
		
#以为采样率只有250Hz，但是我们的上位机使用1KHz的采样率,因此需要插值,每个值后面插三个值
#定义差值后的list
InsertList = list()
for i in range(0, (len(ConvertList)-1)):
	#第一个数,原来的数
	InsertList.append(int(ConvertList[i][0]/4))
	#InsertList.append(int(ConvertList[i][0]))
	#InsertList.append(int(ConvertList[i][0]))
	#InsertList.append(int(ConvertList[i][0]))
	#计算插值分量,即为后一个数减去前一个数/（1KHz/采样率）
	avr = (ConvertList[i+1][0]- ConvertList[i][0]) / (1000/ADC_Fs)
	
	#插值插入第二个数
	InsertList.append(int((ConvertList[i][0] + int(avr))/4))
	#插值插入第三个数
	InsertList.append(int((ConvertList[i][0] + int(avr*2))/4))
	#插值插入第四个数
	InsertList.append(int((ConvertList[i][0] + int(avr*3))/4))


#拆分数据并且输出
i = 0
j = 0
if(len(InsertList) > 125):
	print('Len > 125')
	with open('C:/Users/XIA/Desktop/cu01_cvt.txt','w') as fw:
		while(i < (len(InsertList)-125)):
			fw.write("%02x" % 0xaa)
			fw.write(' ')
			fw.write("%02x" % 0x55)
			fw.write(' ')
			#打印125个数据
			for cnt in range(0,125):
				byteh = InsertList[i] >> 8
				byteh = byteh & 0x00ff
				fw.write("%02x" % byteh)
				fw.write(' ')
				bytel = InsertList[i] & 0x00ff		
				fw.write("%02x" % bytel)
				fw.write(' ')	
				i = i + 1;
			#打印帧尾		
			fw.write("%02x" % j)
			fw.write(' ')		
			fw.write("%02x" % 0x33)
			fw.write(' ')
			fw.write("%02x" % 0xcc)
			fw.write(' ')		
			fw.write('\n')
			j = j + 1
			if(j >= 255):
				j = 0

	fw.close()
else:
	print('Len < 125')
